import { defineComponent as N, computed as $, ref as C, watch as V, shallowRef as P, onMounted as q, createVNode as a, resolveComponent as w, mergeProps as d, toRef as T, unref as _, Fragment as D, nextTick as K, isVNode as z } from "vue";
import { formProps as G, formEmits as H } from "./props.js";
import { dialogProps as J, dialogEmits as Q, ElFormItem as O, ElCol as S } from "element-plus";
import { pickObjByKeys as p, firstUppercase as W, deepClone as X, omitObjByKeys as Y } from "@tomiaa/utils";
import { KCustomElement as v } from "../../customElement/index.js";
import "@wangeditor/editor/dist/css/style.css";
function Z(l) {
  return typeof l == "function" || Object.prototype.toString.call(l) === "[object Object]" && !z(l);
}
const ie = /* @__PURE__ */ N({
  name: "KForm",
  props: G,
  emits: H,
  setup(l, {
    attrs: m,
    slots: c,
    emit: s,
    expose: x
  }) {
    const g = l.modelValue !== void 0, F = ["", !1].includes(m.inline), I = $(() => p(l, Object.keys(J))), j = {};
    for (const e in Q)
      j["on" + W(e)] = (...o) => s(e, ...o);
    const f = C(), L = () => a(w("el-dialog"), d({
      ref: f
    }, j, {
      onClosed: () => {
        var e;
        l.destroyOnClose && (y(), (e = i.value) == null || e.resetFields());
      }
    }, I.value), {
      footer: l.showActions ? k : void 0,
      ...c,
      default: R
    }), k = () => {
      var o;
      let e = [{
        el: "el-button",
        type: "primary",
        "v-if": l.actionsConfig.showSubmit,
        onClick() {
          var n, M;
          const t = {
            formRef: i,
            dialogRef: f,
            formModel: r,
            validate: (n = i.value) == null ? void 0 : n.validate,
            rawFormModel: b()
          };
          if (l.autoValidateOnSubmit) {
            (M = i.value) == null || M.validate((B) => {
              s(B ? "submit" : "submitCheckFail", t);
            });
            return;
          }
          s("submit", t);
        },
        children: l.actionsConfig.submitText ?? "提交"
      }, {
        el: "el-button",
        "v-if": l.actionsConfig.showReset,
        onClick() {
          var t;
          i.value.resetFields(), s("reset", {
            formRef: i,
            dialogRef: f,
            formModel: r,
            validate: (t = i.value) == null ? void 0 : t.validate,
            rawFormModel: b()
          });
        },
        children: l.actionsConfig.resetText ?? "重置"
      }, {
        el: "el-button",
        "v-if": l.actionsConfig.showCancel,
        onClick() {
          s("update:modelValue", !1), s("cancel");
        },
        children: l.actionsConfig.cancelText ?? "取消"
      }];
      return (o = l.actionsConfig) != null && o.custom && (e = l.actionsConfig.custom(e)), g ? a(v, {
        list: e
      }, null) : F ? a(O, null, {
        default: () => [a(v, {
          list: e
        }, null)]
      }) : a(S, l.actionsConfig, {
        default: () => [a(O, null, {
          default: () => [a(v, {
            list: e
          }, null)]
        })]
      });
    }, i = C(), r = C(l.model);
    V(r, (e) => {
      s("update:model", e);
    });
    const y = () => {
      r.value = l.model, l.options.forEach((e) => {
        if (e.prop && typeof e.prop == "string") {
          const o = e.el === "el-upload" ? "fileList" : "modelValue";
          r.value[e.prop] = T(e, o);
        }
      });
    };
    y();
    const b = () => {
      const e = {};
      for (const o in r.value)
        e[o] = _(r.value[o]);
      return e;
    }, R = () => a(w("el-form"), d(m, {
      ref: i,
      model: r.value
    }), {
      default: () => [a(w("el-row"), m, {
        default: () => [A(l.options), l.showActions && !g && k()]
      })]
    }), A = (e) => e.map((o) => {
      if (o = _(o), Array.isArray(o))
        return A(o);
      o.el === "el-upload" && (o.fileList = r.value[o.prop], o["onUpdate:fileList"] = (n) => {
        Object.prototype.hasOwnProperty.call(r.value, o.prop) && (r.value[o.prop] = n);
      });
      let t = {
        ...p(o, Object.keys(S.props).concat("vIf", "v-if")),
        class: o.class ? `${o.class}__el-col` : "",
        el: "el-col",
        children: {
          ...p(o, Object.keys(O.props)),
          class: o.class ? `${o.class}__el-form-item` : "",
          el: "el-form-item",
          children: o
        }
      };
      return F && (t = t.children), o.el === "editor" && (t.children.children = U(o)), a(v, {
        model: r.value,
        list: t
      }, Z(c) ? c : {
        default: () => [c]
      });
    }), u = P({}), U = async (e) => {
      if (e.prop && !u.value[e.prop] && (u.value[e.prop] = P()), typeof window > "u")
        return a(D, null, null);
      const {
        Toolbar: o,
        Editor: t
      } = await import("@wangeditor/editor-for-vue");
      return a(D, null, [a(o, d({
        style: "border-bottom: 1px solid #ccc",
        mode: "default",
        editor: e.prop && u.value[e.prop].value
      }, e.editorAttrs), null), a(t, d({
        style: "height: 300px; width: 100%; overflow-y: hidden",
        mode: "default",
        modelValue: r.value[e.prop],
        "onUpdate:model-value": (n) => {
          Object.prototype.hasOwnProperty.call(r.value, e.prop) && (r.value[e.prop] = n);
        },
        onOnCreated: (n) => {
          e.prop && (u.value[e.prop].value = n, typeof e.ref == "function" ? e.ref(n) : T(e, "ref").value = n);
        }
      }, e.toolbarAttrs), null)]);
    }, h = {
      initFormModel: y,
      getRawFormModel: b,
      setFormModel: async (e, {
        includes: o = [...l.options.map((n) => n.prop).filter((n) => n), "id"],
        exclude: t = []
      } = {}) => {
        e = X(e);
        let n = o != null && o.length ? p(e, o) : e;
        t != null && t.length && (n = Y(n, t)), await K(), Object.assign(r.value, n);
      },
      getFormRef: () => i,
      getDialogRef: () => f,
      formModel: r
    }, E = async () => {
      await K(), Object.assign(h, i.value), Object.assign(h, f.value);
    };
    return q(E), V(() => l.modelValue, E), x(h), () => a("div", null, [g ? L() : R()]);
  }
});
export {
  ie as default
};
