import { dialogProps as e, dialogEmits as t } from "element-plus";
const o = {
  // 合并 dialog 的属性
  ...e,
  // 在弹窗中显示，modelValue 存在也会视为弹窗
  modelValue: {
    type: Boolean,
    default: void 0,
    required: !1
  },
  // 显示操作栏，为 true 时且弹窗时存在 footer 插槽时不会生效
  showActions: {
    type: Boolean,
    default: !0
  },
  // 操作栏配置
  actionsConfig: {
    type: Object,
    default: () => ({})
  },
  // 表单配置
  options: {
    type: Array,
    default: () => []
  },
  // el-form 的 model，接收用于双向绑定
  model: {
    type: Object,
    default: () => ({})
  },
  // submit 时自动校验，校验通过后触发 @submit 事件
  autoValidateOnSubmit: {
    type: Boolean,
    default: !0
  }
}, a = {
  ...t,
  submit: null,
  // 提交
  reset: null,
  // 重置
  cancel: null,
  // 取消
  submitCheckFail: null,
  // autoValidateOnSubmit 为 true 时，submit 校验 form 失败
  "update:model": null
  // 同步model
};
export {
  a as formEmits,
  o as formProps
};
